<template>
  <div id="inputSampah">
    <Navbar title="Input Sampah"/>
    <main class="main-container pt-4 px-3">
      <form>
        <div class="mb-3">
          <label for="kategori" class="form-label">Kategori Sampah</label>
          <select v-model="selectedMaterial" class="form-select text-muted" id="kategori">
            <option disabled value="" selected>Kategori</option>
            <option v-if="materials" v-for="material in materials" :value="material.id">{{material.name}}</option>
          </select>
          <small class="text-danger" v-if="errors.material" > {{errors.material}}</small>
        </div>
        <div class="mb-3">
          <label for="nama_sampah" class="form-label">Nama Sampah</label>
          <input type="text" v-model="inputName" class="form-control text-muted" id="nama_sampah">
          <small class="text-danger" v-if="errors.name" >{{errors.name}}</small>
        </div>
        <div class="d-grid gap-2 mt-2 mb-2">
          <button type="button" @click="storeType()" class="btn btn-color-2">Simpan</button>
        </div>
        <div class="d-grid gap-2 mt-2 mb-2">
          <NuxtLink to="/" class="text-muted text-center">Kembali</NuxtLink>
        </div>
      </form>

    </main>
  </div>
</template>

<script>
export default {
  data(){
    return {
      materials:null,
      selectedMaterial:'',
      inputName:'',
      errors:{
        material:'',
        name:''
      }
    }
  },
  async created(){
    try {
      const list = await this.$axios.$get('/materials')
      // console.log(list.materials);
      this.materials = list.materials

    } catch (error) {
      console.log(error.message);
    }
  },
  methods:{
    storeType:async function() {
      if (!this.formValidation()) {
        console.log('clicked!');

        try {
          const res = await this.$axios.$post('/types', {
            material_id: this.selectedMaterial,
            name: this.inputName
          })
          console.log(res);
          window.location.href = '/';
        } catch (error) {
          console.log(error.message);
        }
      }
    },
    formValidation: function () {
      let hasError = false;
      if (this.selectedMaterial == '') {
        this.$set(this.errors, 'material', 'Field Required')
        hasError=true;
      }
      if (this.inputName == '') {
        this.$set(this.errors, 'name', 'Field Required')
        hasError=true;
      }

      return hasError;
    }
  }
}
</script>
